/*
 * OgreMax Sample Viewer and Scene Loader - Ogre3D-based viewer and code for loading and displaying .scene files
 * Copyright 2013 AND Entertainment
 *
 * This code is available under the OgreMax Free License:
 *   -You may use this code for any purpose, commercial or non-commercial.
 *   -If distributing derived works (that use this source code) in binary or source code form, 
 *    you must give the following credit in your work's end-user documentation: 
 *        "Portions of this work provided by OgreMax (www.ogremax.com)"
 *
 * AND Entertainment assumes no responsibility for any harm caused by using this code.
 * 
 * The OgreMax Sample Viewer and Scene Loader were released at www.ogremax.com 
 */


#ifndef OgreMax_ConvertString_INCLUDED
#define OgreMax_ConvertString_INCLUDED


//Includes---------------------------------------------------------------------
#include <wx/string.h>


//Functions--------------------------------------------------------------------
#if wxMAJOR_VERSION >= 2 && wxMINOR_VERSION >= 9
    #define WxStringAsInternal(wx) (wx).wx_str().AsInternal()
#else
    #define WxStringAsInternal(wx) (wx).wx_str()
#endif

#if wxMAJOR_VERSION >= 2 && wxMINOR_VERSION >= 9
    #define WxStringData(wx) (wx).data()
#else
    #define WxStringData(wx) (wx)
#endif


/** Converts a wxString to an Ogre::String. */
inline Ogre::String WxStringToOgreString(const wxString& wx)
{
#if OGRE_WCHAR_T_STRINGS == wxUSE_UNICODE
    return WxStringAsInternal(wx);
#elif OGRE_WCHAR_T_STRINGS
    return WxStringData(wxConvCurrent->cMB2WC(WxStringAsInternal(wx)));
#else
    return WxStringData(wxConvCurrent->cWC2MB(WxStringAsInternal(wx)));
#endif
}

/** Converts a Ogre::String to a wxString. */
inline wxString OgreStringToWxString(const Ogre::String& ogre)
{
#if OGRE_WCHAR_T_STRINGS == wxUSE_UNICODE
    return WxStringData(ogre.c_str());
#elif OGRE_WCHAR_T_STRINGS
    return WxStringData(wxConvCurrent->cWC2MB(ogre.c_str()));
#else
    return WxStringData(wxConvCurrent->cMB2WC(ogre.c_str()));
#endif
}

#endif
