/*
 * OgreMax Sample Viewer and Scene Loader - Ogre3D-based viewer and code for loading and displaying .scene files
 * Copyright 2013 AND Entertainment
 *
 * This code is available under the OgreMax Free License:
 *   -You may use this code for any purpose, commercial or non-commercial.
 *   -If distributing derived works (that use this source code) in binary or source code form, 
 *    you must give the following credit in your work's end-user documentation: 
 *        "Portions of this work provided by OgreMax (www.ogremax.com)"
 *
 * AND Entertainment assumes no responsibility for any harm caused by using this code.
 * 
 * The OgreMax Sample Viewer and Scene Loader were released at www.ogremax.com 
 */


//Includes---------------------------------------------------------------------
#include "SuspendedUserActionMap.hpp"

using namespace Ogre;
using namespace OgreMax;


//Implementation---------------------------------------------------------------
SuspendedUserActionMap::SuspendedUserActionMap()
{
    this->mappings.reserve(10);

    //Keyboard
    AddActionMapping(InputSource::FromKey(OIS::KC_RETURN), SuspendedUserActionID::UNESCAPE, PRESSED);
    AddActionMapping(InputSource::FromKey(OIS::KC_ESCAPE), SuspendedUserActionID::ESCAPE, PRESSED);

    //Mouse
    AddActionMapping(InputSource::FromMouseButton(0), SuspendedUserActionID::UNESCAPE, PRESSED);
    AddActionMapping(InputSource::FromMouseButton(1), SuspendedUserActionID::UNESCAPE, PRESSED);

    //Joystick
    AddActionMapping(InputSource::FromJoystickButton(1), SuspendedUserActionID::ESCAPE, PRESSED); //"Back" on the Xbox 360 controller
}

void SuspendedUserActionMap::AddEvent
    (
    SuspendedUserEvents& events,
    SuspendedUserActionID::Type actionID,
    InputSource::DeviceType deviceType,
    TriggerFlags trigger,
    Real amount
    )
{
    switch (actionID)
    {
        case SuspendedUserActionID::ESCAPE: events.AddEvent(SuspendedUserEventID::ESCAPE); break;
        case SuspendedUserActionID::UNESCAPE: events.AddEvent(SuspendedUserEventID::UNESCAPE); break;
    }
}
