/*
 * OgreMax Sample Viewer and Scene Loader - Ogre3D-based viewer and code for loading and displaying .scene files
 * Copyright 2013 AND Entertainment
 *
 * This code is available under the OgreMax Free License:
 *   -You may use this code for any purpose, commercial or non-commercial.
 *   -If distributing derived works (that use this source code) in binary or source code form, 
 *    you must give the following credit in your work's end-user documentation: 
 *        "Portions of this work provided by OgreMax (www.ogremax.com)"
 *
 * AND Entertainment assumes no responsibility for any harm caused by using this code.
 * 
 * The OgreMax Sample Viewer and Scene Loader were released at www.ogremax.com 
 */

/**
 * This program is essentially the same as the OgreMax Viewer, with a few differences:
 *      -Lua support and all associated functions have been removed.
 *      -Drag and drop support has been removed.
 *      -Resource locations specified on the command line are ignored.
 *      -Only scene files may be viewed.
 * These changes make the program a little easier to understand and compile.
 */

//Includes---------------------------------------------------------------------
#include <wx/app.h>
#include "Application.hpp"

using namespace Ogre;
using namespace OgreMax;


//Local classes----------------------------------------------------------------
class Main : public wxApp
{
public:
    Main();

    bool OnInit();
    int OnRun();
};


//Implementation---------------------------------------------------------------
IMPLEMENT_APP(Main)

Main::Main()
{
}

bool Main::OnInit()
{
    setlocale(LC_CTYPE, "");
    return true;
}

int Main::OnRun()
{
    Application::GetInstance().Run(this->argc, this->argv);        
    return 0;
}
